diff -ruNp ejudge-2.3.18/super_html_2.c ejudge/super_html_2.c
--- ejudge-2.3.18/super_html_2.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/super_html_2.c	2011-07-11 09:02:04.561273069 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: super_html_2.c 6162 2011-03-27 07:07:27Z cher $ */
+/* $Id: super_html_2.c 6351 2011-05-24 19:28:45Z cher $ */
 
 /* Copyright (C) 2005-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -125,6 +125,8 @@ super_html_clear_variable(struct sid_sta
   case SSERV_CMD_CNTS_CLEAR_TEAM_URL: p_str = &cnts->team_url; break;
   case SSERV_CMD_CNTS_CLEAR_STANDINGS_URL: p_str = &cnts->standings_url; break;
   case SSERV_CMD_CNTS_CLEAR_PROBLEMS_URL: p_str = &cnts->problems_url; break;
+  case SSERV_CMD_CNTS_CLEAR_LOGO_URL: p_str = &cnts->logo_url; break;
+  case SSERV_CMD_CNTS_CLEAR_CSS_URL: p_str = &cnts->css_url; break;
   case SSERV_CMD_CNTS_CLEAR_ROOT_DIR: p_str = &cnts->root_dir; break;
   case SSERV_CMD_CNTS_CLEAR_CONF_DIR: p_str = &cnts->conf_dir; break;
   case SSERV_CMD_CNTS_CLEAR_DIR_MODE: p_str = &cnts->dir_mode; break;
@@ -265,6 +267,7 @@ super_html_set_contest_var(struct sid_st
                            int param3, int param4, int param5)
 {
   unsigned char **p_str = 0, **p_str_d2u = 0;
+  unsigned char **p_email = 0;
   unsigned char *p_bool = 0;
   time_t *p_date = 0;
   int v, n, memb_ind;
@@ -450,13 +453,13 @@ super_html_set_contest_var(struct sid_st
     p_str = &cnts->allowed_regions;
     break;
   case SSERV_CMD_CNTS_CHANGE_CF_NOTIFY_EMAIL:
-    p_str = &cnts->cf_notify_email;
+    p_email = &cnts->cf_notify_email;
     break;
   case SSERV_CMD_CNTS_CHANGE_CLAR_NOTIFY_EMAIL:
-    p_str = &cnts->clar_notify_email;
+    p_email = &cnts->clar_notify_email;
     break;
   case SSERV_CMD_CNTS_CHANGE_DAILY_STAT_EMAIL:
-    p_str = &cnts->daily_stat_email;
+    p_email = &cnts->daily_stat_email;
     break;
   case SSERV_CMD_CNTS_CHANGE_TEAM_HEAD_STYLE:
     p_str = &cnts->team_head_style;
@@ -465,7 +468,7 @@ super_html_set_contest_var(struct sid_st
     p_str = &cnts->team_par_style;
     break;
   case SSERV_CMD_CNTS_CHANGE_REGISTER_EMAIL:
-    p_str = &cnts->register_email;
+    p_email = &cnts->register_email;
     break;
   case SSERV_CMD_CNTS_CHANGE_REGISTER_URL:
     p_str = &cnts->register_url;
@@ -488,6 +491,12 @@ super_html_set_contest_var(struct sid_st
   case SSERV_CMD_CNTS_CHANGE_PROBLEMS_URL:
     p_str = &cnts->problems_url;
     break;
+  case SSERV_CMD_CNTS_CHANGE_LOGO_URL:
+    p_str = &cnts->logo_url;
+    break;
+  case SSERV_CMD_CNTS_CHANGE_CSS_URL:
+    p_str = &cnts->css_url;
+    break;
   case SSERV_CMD_CNTS_CHANGE_ROOT_DIR:
     p_str = &cnts->root_dir;
     break;
@@ -716,6 +725,12 @@ super_html_set_contest_var(struct sid_st
     abort();
   }
 
+  if (p_email) {
+    if (param2 && *param2 && !is_valid_email_address(param2))
+      return -SSERV_ERR_INVALID_PARAMETER;
+    p_str = p_email; p_email = 0;
+  }
+
   if (p_date) {
     if (xml_parse_date("", 0, 0, param2, p_date) < 0)
       return -SSERV_ERR_INVALID_PARAMETER;
diff -ruNp ejudge-2.3.18/super_html_3.c ejudge/super_html_3.c
--- ejudge-2.3.18/super_html_3.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/super_html_3.c	2011-07-11 09:02:04.652271396 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: super_html_3.c 6240 2011-04-09 04:50:34Z cher $ */
+/* $Id: super_html_3.c 6351 2011-05-24 19:28:45Z cher $ */
 
 /* Copyright (C) 2005-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -73,9 +73,6 @@ static const unsigned char * const form_
   " bgcolor=\"#e0e0e0\"",
 };
 
-static int
-num_suffix(const unsigned char *str);
-
 static void
 html_submit_button(FILE *f,
                    int action,
@@ -251,6 +248,7 @@ static const unsigned char * const actio
   [SSERV_CMD_CNTS_CHANGE_TEAM_URL] = "Contest.xml:team_url",
   [SSERV_CMD_CNTS_CHANGE_STANDINGS_URL] = "Contest.xml:standings_url",
   [SSERV_CMD_CNTS_CHANGE_PROBLEMS_URL] = "Contest.xml:problems_url",
+  [SSERV_CMD_CNTS_CHANGE_LOGO_URL] = "Contest.xml:logo_url",
   [SSERV_CMD_CNTS_CHANGE_ROOT_DIR] = "Contest.xml:root_dir",
   [SSERV_CMD_CNTS_CHANGE_CONF_DIR] = "Contest.xml:conf_dir",
   [SSERV_CMD_CNTS_CHANGE_DIR_MODE] = "Contest.xml:dir_mode",
@@ -2768,7 +2766,7 @@ super_html_global_param(struct sid_state
                         int param3, int param4)
 {
   struct section_global_data *global = sstate->global;
-  int hh, mm, n, val, default_val, mult;
+  int hh, mm, n, val, default_val;
   unsigned char *s;
   int *p_int;
   unsigned char *p_str;
@@ -3097,16 +3095,8 @@ super_html_global_param(struct sid_state
     p_size = &global->compile_max_vm_size;
 
   handle_size_t:
-    if (!param2) return -SSERV_ERR_INVALID_PARAMETER;
-    if (sscanf(param2, "%d%n", &val, &n) == 1 && !param2[n] && val == -1) {
-      *p_size = -1L;
-      return 0;
-    }
-    if (sscanf(param2, "%zu%n", &zval, &n) != 1)
-      return -SSERV_ERR_INVALID_PARAMETER;
-    if (!(mult = num_suffix(param2 + n))) return -SSERV_ERR_INVALID_PARAMETER;
-    // FIXME: check for overflow
-    zval *= mult;
+    zval = 0;
+    if (size_str_to_size_t(param2, &zval) < 0) return -SSERV_ERR_INVALID_PARAMETER;
     *p_size = zval;
     return 0;
 
@@ -4470,7 +4460,7 @@ super_html_lang_cmd(struct sid_state *ss
                     int param3, int param4)
 {
   struct section_language_data *pl_old, *pl_new;
-  int val, n, mult;
+  int val, n;
   int *p_int;
   size_t *p_size, zval;
   char **tmp_env = 0;
@@ -4587,16 +4577,8 @@ super_html_lang_cmd(struct sid_state *ss
     p_size = &pl_new->max_vm_size;
 
   handle_size_t:
-    if (!param2) return -SSERV_ERR_INVALID_PARAMETER;
-    if (sscanf(param2, "%d%n", &val, &n) == 1 && !param2[n] && val == -1) {
-      *p_size = -1L;
-      return 0;
-    }
-    if (sscanf(param2, "%zu%n", &zval, &n) != 1)
-      return -SSERV_ERR_INVALID_PARAMETER;
-    if (!(mult = num_suffix(param2 + n))) return -SSERV_ERR_INVALID_PARAMETER;
-    // FIXME: check for overflow
-    zval *= mult;
+    zval = 0;
+    if (size_str_to_size_t(param2, &zval) < 0) return -SSERV_ERR_INVALID_PARAMETER;
     *p_size = zval;
     return 0;
 
@@ -7373,24 +7355,13 @@ super_html_prob_cmd(struct sid_state *ss
 #define PROB_ASSIGN_STRING(f) snprintf(prob->f, sizeof(prob->f), "%s", param2)
 #define PROB_CLEAR_STRING(f) prob->f[0] = 0
 
-static int
-num_suffix(const unsigned char *str)
-{
-  if (!str[0]) return 1;
-  if (str[1]) return 0; 
-  if (str[0] == 'k' || str[0] == 'K') return 1024;
-  if (str[0] == 'm' || str[0] == 'M') return 1024 * 1024;
-  if (str[0] == 'g' || str[0] == 'G') return 1024 * 1024 * 1024;
-  return 0;
-}
-
 int
 super_html_prob_param(struct sid_state *sstate, int cmd,
                       int prob_id, const unsigned char *param2,
                       int param3, int param4)
 {
   struct section_problem_data *prob;
-  int i, n, val, mult;
+  int i, n, val;
   int *p_int;
   char **tmp_env = 0;
   size_t *p_size, zval;
@@ -7758,16 +7729,8 @@ super_html_prob_param(struct sid_state *
     p_size = &prob->max_vm_size;
 
   handle_size_t:
-    if (!param2) return -SSERV_ERR_INVALID_PARAMETER;
-    if (sscanf(param2, "%d%n", &val, &n) == 1 && !param2[n] && val == -1) {
-      *p_size = -1L;
-      return 0;
-    }
-    if (sscanf(param2, "%zu%n", &zval, &n) != 1)
-      return -SSERV_ERR_INVALID_PARAMETER;
-    if (!(mult = num_suffix(param2 + n))) return -SSERV_ERR_INVALID_PARAMETER;
-    // FIXME: check for overflow
-    zval *= mult;
+    zval = 0;
+    if (size_str_to_size_t(param2, &zval) < 0) return -SSERV_ERR_INVALID_PARAMETER;
     *p_size = zval;
     return 0;
 
diff -ruNp ejudge-2.3.18/super_html_4.c ejudge/super_html_4.c
--- ejudge-2.3.18/super_html_4.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/super_html_4.c	2011-07-11 09:02:04.730269961 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: super_html_4.c 6235 2011-04-08 17:43:53Z cher $ */
+/* $Id: super_html_4.c 6401 2011-07-09 09:38:23Z cher $ */
 
 /* Copyright (C) 2008-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -40,6 +40,7 @@
 #include "prepare_dflt.h"
 #include "cpu.h"
 #include "compat.h"
+#include "errlog.h"
 
 #include "reuse_xalloc.h"
 #include "reuse_logger.h"
@@ -50,6 +51,7 @@
 #include <stdlib.h>
 #include <stdarg.h>
 #include <sys/stat.h>
+#include <dlfcn.h>
 
 #if !defined CONF_STYLE_PREFIX
 #define CONF_STYLE_PREFIX "/ejudge/"
@@ -180,7 +182,7 @@ ss_cgi_nname(
   return 0;
 }
 
-static int
+int
 ss_cgi_param_int(
         struct super_http_request_info *phr,
         const unsigned char *name,
@@ -198,7 +200,7 @@ ss_cgi_param_int(
   return 0;
 }
 
-static int
+int
 ss_cgi_param_int_opt(
         struct super_http_request_info *phr,
         const unsigned char *name,
@@ -407,8 +409,8 @@ write_html_header(
             "</style>\n",
             CONF_STYLE_PREFIX, CONF_STYLE_PREFIX, CONF_STYLE_PREFIX,
             CONF_STYLE_PREFIX, CONF_STYLE_PREFIX);
+    fprintf(out_f, "<style type=\"text/css\" id=\"generatedStyles\"></style>\n");
   }
-  fprintf(out_f, "<style type=\"text/css\" id=\"generatedStyles\"></style>\n");
 
   if (use_dojo) {
     fprintf(out_f, "<script type=\"text/javascript\" src=\"%sdojo/dojo.js\" djConfig=\"isDebug: false, parseOnLoad: true, dojoIframeHistoryUrl:'%sdojo/resources/iframe_history.html'\"></script>\n",
@@ -992,6 +994,8 @@ static const struct cnts_edit_info cnts_
   { NS_CONTEST, CNTS_team_url, 's', 1, 1, 1, 1, 0, "URL for the client CGI program", "URL for the client CGI program", 0 },
   { NS_CONTEST, CNTS_standings_url, 's', 1, 1, 1, 1, 0, "URL for the current standings", "URL for the current standings", 0 },
   { NS_CONTEST, CNTS_problems_url, 's', 1, 1, 1, 1, 0, "URL for the problemset", "URL for the problemset", 0 },
+  { NS_CONTEST, CNTS_logo_url, 's', 1, 1, 1, 1, 0, "URL for the contest logo", "URL for the contest logo", 0 },
+  { NS_CONTEST, CNTS_css_url, 's', 1, 1, 1, 1, 0, "URL for the contest CSS", "URL for the contest CSS", 0 },
   { 0, 0, '-', 0, 0, 0, 0, 0, "Contest Management", 0, 0 },
   { NS_CONTEST, CNTS_managed, 'y', 1, 0, 0, 0, 0, "Enable the contest service", "Enable the contest service", 0 },
   { NS_CONTEST, CNTS_run_managed, 'y', 1, 0, 0, 0, 0, "Enable the run service", "Enable the run service", 0 },
@@ -2977,6 +2981,14 @@ cmd_edit_contest_xml_field(
         if ((newval = l10n_parse_locale(valstr)) < 0)
           FAIL(S_ERR_INV_VALUE);
       }
+      if (f_id == CNTS_register_email
+          || f_id == CNTS_cf_notify_email
+          || f_id == CNTS_clar_notify_email
+          || f_id == CNTS_daily_stat_email) {
+        if (valstr && *valstr && !is_valid_email_address(valstr)) {
+          FAIL(S_ERR_INV_VALUE);
+        }
+      }
 
       if (!*p_str) {
         retval = 1;
@@ -6476,6 +6488,203 @@ cmd_op_edit_serve_prob_field_detail(
   return retval;
 }
 
+static const unsigned char * const op_names[SSERV_OP_LAST] =
+{
+  [SSERV_OP_VIEW_CNTS_DETAILS] = "VIEW_CNTS_DETAILS",
+  [SSERV_OP_EDITED_CNTS_BACK] = "EDITED_CNTS_BACK",
+  [SSERV_OP_EDITED_CNTS_CONTINUE] = "EDITED_CNTS_CONTINUE",
+  [SSERV_OP_EDITED_CNTS_START_NEW] = "EDITED_CNTS_START_NEW",
+  [SSERV_OP_LOCKED_CNTS_FORGET] = "LOCKED_CNTS_FORGET",
+  [SSERV_OP_LOCKED_CNTS_CONTINUE] = "LOCKED_CNTS_CONTINUE",
+  [SSERV_OP_EDIT_CONTEST_PAGE] = "EDIT_CONTEST_PAGE",
+  [SSERV_OP_EDIT_CONTEST_PAGE_2] = "EDIT_CONTEST_PAGE_2",
+  [SSERV_OP_CLEAR_CONTEST_XML_FIELD] = "CLEAR_CONTEST_XML_FIELD",
+  [SSERV_OP_EDIT_CONTEST_XML_FIELD] = "EDIT_CONTEST_XML_FIELD",
+  [SSERV_OP_TOGGLE_CONTEST_XML_VISIBILITY] = "TOGGLE_CONTEST_XML_VISIBILITY",
+  [SSERV_OP_CONTEST_XML_FIELD_EDIT_PAGE] = "CONTEST_XML_FIELD_EDIT_PAGE",
+  [SSERV_OP_SAVE_FILE_CONTEST_XML] = "SAVE_FILE_CONTEST_XML",
+  [SSERV_OP_CLEAR_FILE_CONTEST_XML] = "CLEAR_FILE_CONTEST_XML",
+  [SSERV_OP_RELOAD_FILE_CONTEST_XML] = "RELOAD_FILE_CONTEST_XML",
+  [SSERV_OP_COPY_ACCESS_RULES_PAGE] = "COPY_ACCESS_RULES_PAGE",
+  [SSERV_OP_COPY_ALL_ACCESS_RULES_PAGE] = "COPY_ALL_ACCESS_RULES_PAGE",
+  [SSERV_OP_COPY_ALL_ACCESS_RULES] = "COPY_ALL_ACCESS_RULES",
+  [SSERV_OP_COPY_ALL_PRIV_USERS_PAGE] = "COPY_ALL_PRIV_USERS_PAGE",
+  [SSERV_OP_COPY_ALL_PRIV_USERS] = "COPY_ALL_PRIV_USERS",
+  [SSERV_OP_ADD_PRIV_USER] = "ADD_PRIV_USER",
+  [SSERV_OP_EDIT_PERMISSIONS_PAGE] = "EDIT_PERMISSIONS_PAGE",
+  [SSERV_OP_EDIT_GENERAL_FIELDS_PAGE] = "EDIT_GENERAL_FIELDS_PAGE",
+  [SSERV_OP_EDIT_MEMBER_FIELDS_PAGE] = "EDIT_MEMBER_FIELDS_PAGE",
+  [SSERV_OP_DELETE_PRIV_USER] = "DELETE_PRIV_USER",
+  [SSERV_OP_SET_PREDEF_PRIV] = "SET_PREDEF_PRIV",
+  [SSERV_OP_SET_PRIV] = "SET_PRIV",
+  [SSERV_OP_SET_DEFAULT_ACCESS] = "SET_DEFAULT_ACCESS",
+  [SSERV_OP_CHECK_IP_MASK] = "CHECK_IP_MASK",
+  [SSERV_OP_ADD_IP] = "ADD_IP",
+  [SSERV_OP_SET_RULE_ACCESS] = "SET_RULE_ACCESS",
+  [SSERV_OP_SET_RULE_SSL] = "SET_RULE_SSL",
+  [SSERV_OP_SET_RULE_IP] = "SET_RULE_IP",
+  [SSERV_OP_DELETE_RULE] = "DELETE_RULE",
+  [SSERV_OP_FORWARD_RULE] = "FORWARD_RULE",
+  [SSERV_OP_BACKWARD_RULE] = "BACKWARD_RULE",
+  [SSERV_OP_COPY_ACCESS_RULES] = "COPY_ACCESS_RULES",
+  [SSERV_OP_EDIT_GENERAL_FIELDS] = "EDIT_GENERAL_FIELDS",
+  [SSERV_OP_EDIT_MEMBER_FIELDS] = "EDIT_MEMBER_FIELDS",
+  [SSERV_OP_CREATE_NEW_CONTEST_PAGE] = "CREATE_NEW_CONTEST_PAGE",
+  [SSERV_OP_CREATE_NEW_CONTEST] = "CREATE_NEW_CONTEST",
+  [SSERV_OP_FORGET_CONTEST] = "FORGET_CONTEST",
+  [SSERV_OP_EDIT_SERVE_GLOBAL_FIELD] = "EDIT_SERVE_GLOBAL_FIELD",
+  [SSERV_OP_CLEAR_SERVE_GLOBAL_FIELD] = "CLEAR_SERVE_GLOBAL_FIELD",
+  [SSERV_OP_EDIT_SID_STATE_FIELD] = "EDIT_SID_STATE_FIELD",
+  [SSERV_OP_EDIT_SID_STATE_FIELD_NEGATED] = "EDIT_SID_STATE_FIELD_NEGATED",
+  [SSERV_OP_EDIT_SERVE_GLOBAL_FIELD_DETAIL_PAGE] = "EDIT_SERVE_GLOBAL_FIELD_DETAIL_PAGE",
+  [SSERV_OP_EDIT_SERVE_GLOBAL_FIELD_DETAIL] = "EDIT_SERVE_GLOBAL_FIELD_DETAIL",
+  [SSERV_OP_SET_SID_STATE_LANG_FIELD] = "SET_SID_STATE_LANG_FIELD",
+  [SSERV_OP_CLEAR_SID_STATE_LANG_FIELD] = "CLEAR_SID_STATE_LANG_FIELD",
+  [SSERV_OP_SET_SERVE_LANG_FIELD] = "SET_SERVE_LANG_FIELD",
+  [SSERV_OP_CLEAR_SERVE_LANG_FIELD] = "CLEAR_SERVE_LANG_FIELD",
+  [SSERV_OP_EDIT_SERVE_LANG_FIELD_DETAIL_PAGE] = "EDIT_SERVE_LANG_FIELD_DETAIL_PAGE",
+  [SSERV_OP_EDIT_SERVE_LANG_FIELD_DETAIL] = "EDIT_SERVE_LANG_FIELD_DETAIL",
+  [SSERV_OP_SERVE_LANG_UPDATE_VERSIONS] = "SERVE_LANG_UPDATE_VERSIONS",
+  [SSERV_OP_CREATE_ABSTR_PROB] = "CREATE_ABSTR_PROB",
+  [SSERV_OP_CREATE_CONCRETE_PROB] = "CREATE_CONCRETE_PROB",
+  [SSERV_OP_DELETE_PROB] = "DELETE_PROB",
+  [SSERV_OP_SET_SID_STATE_PROB_FIELD] = "SET_SID_STATE_PROB_FIELD",
+  [SSERV_OP_SET_SERVE_PROB_FIELD] = "SET_SERVE_PROB_FIELD",
+  [SSERV_OP_CLEAR_SERVE_PROB_FIELD] = "CLEAR_SERVE_PROB_FIELD",
+  [SSERV_OP_EDIT_SERVE_PROB_FIELD_DETAIL_PAGE] = "EDIT_SERVE_PROB_FIELD_DETAIL_PAGE",
+  [SSERV_OP_EDIT_SERVE_PROB_FIELD_DETAIL] = "EDIT_SERVE_PROB_FIELD_DETAIL",
+  [SSERV_OP_BROWSE_PROBLEM_PACKAGES] = "BROWSE_PROBLEM_PACKAGES",
+  [SSERV_OP_CREATE_PACKAGE] = "CREATE_PACKAGE",
+  [SSERV_OP_CREATE_PROBLEM] = "CREATE_PROBLEM",
+  [SSERV_OP_DELETE_ITEM] = "DELETE_ITEM",
+  [SSERV_OP_EDIT_PROBLEM] = "EDIT_PROBLEM",
+  [SSERV_OP_USER_BROWSE_PAGE] = "USER_BROWSE_PAGE",
+  [SSERV_OP_USER_FILTER_CHANGE_ACTION] = "USER_FILTER_CHANGE_ACTION",
+  [SSERV_OP_USER_FILTER_FIRST_PAGE_ACTION] = "USER_FILTER_FIRST_PAGE_ACTION",
+  [SSERV_OP_USER_FILTER_PREV_PAGE_ACTION] = "USER_FILTER_PREV_PAGE_ACTION",
+  [SSERV_OP_USER_FILTER_NEXT_PAGE_ACTION] = "USER_FILTER_NEXT_PAGE_ACTION",
+  [SSERV_OP_USER_FILTER_LAST_PAGE_ACTION] = "USER_FILTER_LAST_PAGE_ACTION",
+  [SSERV_OP_USER_JUMP_CONTEST_ACTION] = "USER_JUMP_CONTEST_ACTION",
+  [SSERV_OP_USER_JUMP_GROUP_ACTION] = "USER_JUMP_GROUP_ACTION",
+  [SSERV_OP_USER_BROWSE_MARK_ALL_ACTION] = "USER_BROWSE_MARK_ALL_ACTION",
+  [SSERV_OP_USER_BROWSE_UNMARK_ALL_ACTION] = "USER_BROWSE_UNMARK_ALL_ACTION",
+  [SSERV_OP_USER_BROWSE_TOGGLE_ALL_ACTION] = "USER_BROWSE_TOGGLE_ALL_ACTION",
+  [SSERV_OP_USER_CREATE_ONE_PAGE] = "USER_CREATE_ONE_PAGE",
+  [SSERV_OP_USER_CREATE_ONE_ACTION] = "USER_CREATE_ONE_ACTION",
+  [SSERV_OP_USER_CREATE_MANY_PAGE] = "USER_CREATE_MANY_PAGE",
+  [SSERV_OP_USER_CREATE_MANY_ACTION] = "USER_CREATE_MANY_ACTION",
+  [SSERV_OP_USER_CREATE_FROM_CSV_PAGE] = "USER_CREATE_FROM_CSV_PAGE",
+  [SSERV_OP_USER_CREATE_FROM_CSV_ACTION] = "USER_CREATE_FROM_CSV_ACTION",
+  [SSERV_OP_USER_DETAIL_PAGE] = "USER_DETAIL_PAGE",
+  [SSERV_OP_USER_PASSWORD_PAGE] = "USER_PASSWORD_PAGE",
+  [SSERV_OP_USER_CHANGE_PASSWORD_ACTION] = "USER_CHANGE_PASSWORD_ACTION",
+  [SSERV_OP_USER_CNTS_PASSWORD_PAGE] = "USER_CNTS_PASSWORD_PAGE",
+  [SSERV_OP_USER_CHANGE_CNTS_PASSWORD_ACTION] = "USER_CHANGE_CNTS_PASSWORD_ACTION",
+  [SSERV_OP_USER_CLEAR_FIELD_ACTION] = "USER_CLEAR_FIELD_ACTION",
+  [SSERV_OP_USER_CREATE_MEMBER_ACTION] = "USER_CREATE_MEMBER_ACTION",
+  [SSERV_OP_USER_DELETE_MEMBER_PAGE] = "USER_DELETE_MEMBER_PAGE",
+  [SSERV_OP_USER_DELETE_MEMBER_ACTION] = "USER_DELETE_MEMBER_ACTION",
+  [SSERV_OP_USER_SAVE_AND_PREV_ACTION] = "USER_SAVE_AND_PREV_ACTION",
+  [SSERV_OP_USER_SAVE_ACTION] = "USER_SAVE_ACTION",
+  [SSERV_OP_USER_SAVE_AND_NEXT_ACTION] = "USER_SAVE_AND_NEXT_ACTION",
+  [SSERV_OP_USER_CANCEL_AND_PREV_ACTION] = "USER_CANCEL_AND_PREV_ACTION",
+  [SSERV_OP_USER_CANCEL_ACTION] = "USER_CANCEL_ACTION",
+  [SSERV_OP_USER_CANCEL_AND_NEXT_ACTION] = "USER_CANCEL_AND_NEXT_ACTION",
+  [SSERV_OP_USER_CREATE_REG_PAGE] = "USER_CREATE_REG_PAGE",
+  [SSERV_OP_USER_CREATE_REG_ACTION] = "USER_CREATE_REG_ACTION",
+  [SSERV_OP_USER_EDIT_REG_PAGE] = "USER_EDIT_REG_PAGE",
+  [SSERV_OP_USER_EDIT_REG_ACTION] = "USER_EDIT_REG_ACTION",
+  [SSERV_OP_USER_DELETE_REG_PAGE] = "USER_DELETE_REG_PAGE",
+  [SSERV_OP_USER_DELETE_REG_ACTION] = "USER_DELETE_REG_ACTION",
+  [SSERV_OP_USER_DELETE_SESSION_ACTION] = "USER_DELETE_SESSION_ACTION",
+  [SSERV_OP_USER_DELETE_ALL_SESSIONS_ACTION] = "USER_DELETE_ALL_SESSIONS_ACTION",
+  [SSERV_OP_USER_SEL_RANDOM_PASSWD_PAGE] = "USER_SEL_RANDOM_PASSWD_PAGE",
+  [SSERV_OP_USER_SEL_RANDOM_PASSWD_ACTION] = "USER_SEL_RANDOM_PASSWD_ACTION",
+  [SSERV_OP_USER_SEL_CLEAR_CNTS_PASSWD_PAGE] = "USER_SEL_CLEAR_CNTS_PASSWD_PAGE",
+  [SSERV_OP_USER_SEL_CLEAR_CNTS_PASSWD_ACTION] = "USER_SEL_CLEAR_CNTS_PASSWD_ACTION",
+  [SSERV_OP_USER_SEL_RANDOM_CNTS_PASSWD_PAGE] = "USER_SEL_RANDOM_CNTS_PASSWD_PAGE",
+  [SSERV_OP_USER_SEL_RANDOM_CNTS_PASSWD_ACTION] = "USER_SEL_RANDOM_CNTS_PASSWD_ACTION",
+  [SSERV_OP_USER_SEL_CREATE_REG_PAGE] = "USER_SEL_CREATE_REG_PAGE",
+  [SSERV_OP_USER_SEL_CREATE_REG_ACTION] = "USER_SEL_CREATE_REG_ACTION",
+  [SSERV_OP_USER_SEL_CREATE_REG_AND_COPY_PAGE] = "USER_SEL_CREATE_REG_AND_COPY_PAGE",
+  [SSERV_OP_USER_SEL_CREATE_REG_AND_COPY_ACTION] = "USER_SEL_CREATE_REG_AND_COPY_ACTION",
+  [SSERV_OP_USER_SEL_DELETE_REG_PAGE] = "USER_SEL_DELETE_REG_PAGE",
+  [SSERV_OP_USER_SEL_DELETE_REG_ACTION] = "USER_SEL_DELETE_REG_ACTION",
+  [SSERV_OP_USER_SEL_CHANGE_REG_STATUS_PAGE] = "USER_SEL_CHANGE_REG_STATUS_PAGE",
+  [SSERV_OP_USER_SEL_CHANGE_REG_STATUS_ACTION] = "USER_SEL_CHANGE_REG_STATUS_ACTION",
+  [SSERV_OP_USER_SEL_CHANGE_REG_FLAGS_PAGE] = "USER_SEL_CHANGE_REG_FLAGS_PAGE",
+  [SSERV_OP_USER_SEL_CHANGE_REG_FLAGS_ACTION] = "USER_SEL_CHANGE_REG_FLAGS_ACTION",
+  [SSERV_OP_USER_SEL_CANCEL_ACTION] = "USER_SEL_CANCEL_ACTION",
+  [SSERV_OP_USER_SEL_VIEW_PASSWD_PAGE] = "USER_SEL_VIEW_PASSWD_PAGE",
+  [SSERV_OP_USER_SEL_VIEW_CNTS_PASSWD_PAGE] = "USER_SEL_VIEW_CNTS_PASSWD_PAGE",
+  [SSERV_OP_USER_SEL_VIEW_PASSWD_REDIRECT] = "USER_SEL_VIEW_PASSWD_REDIRECT",
+  [SSERV_OP_USER_SEL_VIEW_CNTS_PASSWD_REDIRECT] = "USER_SEL_VIEW_CNTS_PASSWD_REDIRECT",
+  [SSERV_OP_USER_SEL_CREATE_GROUP_MEMBER_PAGE] = "USER_SEL_CREATE_GROUP_MEMBER_PAGE",
+  [SSERV_OP_USER_SEL_CREATE_GROUP_MEMBER_ACTION] = "USER_SEL_CREATE_GROUP_MEMBER_ACTION",
+  [SSERV_OP_USER_SEL_DELETE_GROUP_MEMBER_PAGE] = "USER_SEL_DELETE_GROUP_MEMBER_PAGE",
+  [SSERV_OP_USER_SEL_DELETE_GROUP_MEMBER_ACTION] = "USER_SEL_DELETE_GROUP_MEMBER_ACTION",
+  [SSERV_OP_GROUP_BROWSE_PAGE] = "GROUP_BROWSE_PAGE",
+  [SSERV_OP_GROUP_FILTER_CHANGE_ACTION] = "GROUP_FILTER_CHANGE_ACTION",
+  [SSERV_OP_GROUP_FILTER_FIRST_PAGE_ACTION] = "GROUP_FILTER_FIRST_PAGE_ACTION",
+  [SSERV_OP_GROUP_FILTER_PREV_PAGE_ACTION] = "GROUP_FILTER_PREV_PAGE_ACTION",
+  [SSERV_OP_GROUP_FILTER_NEXT_PAGE_ACTION] = "GROUP_FILTER_NEXT_PAGE_ACTION",
+  [SSERV_OP_GROUP_FILTER_LAST_PAGE_ACTION] = "GROUP_FILTER_LAST_PAGE_ACTION",
+  [SSERV_OP_GROUP_CREATE_PAGE] = "GROUP_CREATE_PAGE",
+  [SSERV_OP_GROUP_CREATE_ACTION] = "GROUP_CREATE_ACTION",
+  [SSERV_OP_GROUP_MODIFY_PAGE] = "GROUP_MODIFY_PAGE",
+  [SSERV_OP_GROUP_MODIFY_PAGE_ACTION] = "GROUP_MODIFY_PAGE_ACTION",
+  [SSERV_OP_GROUP_MODIFY_ACTION] = "GROUP_MODIFY_ACTION",
+  [SSERV_OP_GROUP_DELETE_PAGE] = "GROUP_DELETE_PAGE",
+  [SSERV_OP_GROUP_DELETE_PAGE_ACTION] = "GROUP_DELETE_PAGE_ACTION",
+  [SSERV_OP_GROUP_DELETE_ACTION] = "GROUP_DELETE_ACTION",
+  [SSERV_OP_GROUP_CANCEL_ACTION] = "GROUP_CANCEL_ACTION",
+};
+
+static const int op_redirect[SSERV_OP_LAST] =
+{
+  [SSERV_OP_USER_FILTER_FIRST_PAGE_ACTION] = SSERV_OP_USER_FILTER_CHANGE_ACTION,
+  [SSERV_OP_USER_FILTER_PREV_PAGE_ACTION] = SSERV_OP_USER_FILTER_CHANGE_ACTION,
+  [SSERV_OP_USER_FILTER_NEXT_PAGE_ACTION] = SSERV_OP_USER_FILTER_CHANGE_ACTION,
+  [SSERV_OP_USER_FILTER_LAST_PAGE_ACTION] = SSERV_OP_USER_FILTER_CHANGE_ACTION,
+
+  [SSERV_OP_USER_BROWSE_UNMARK_ALL_ACTION] = SSERV_OP_USER_BROWSE_MARK_ALL_ACTION,
+  [SSERV_OP_USER_BROWSE_TOGGLE_ALL_ACTION] = SSERV_OP_USER_BROWSE_MARK_ALL_ACTION,
+
+  [SSERV_OP_USER_SAVE_AND_PREV_ACTION] = SSERV_OP_USER_SAVE_ACTION,
+  [SSERV_OP_USER_SAVE_AND_NEXT_ACTION] = SSERV_OP_USER_SAVE_ACTION,
+
+  [SSERV_OP_USER_CANCEL_AND_PREV_ACTION] = SSERV_OP_USER_CANCEL_ACTION,
+  [SSERV_OP_USER_CANCEL_AND_NEXT_ACTION] = SSERV_OP_USER_CANCEL_ACTION,
+
+  [SSERV_OP_USER_SEL_CLEAR_CNTS_PASSWD_PAGE] = SSERV_OP_USER_SEL_RANDOM_PASSWD_PAGE,
+  [SSERV_OP_USER_SEL_RANDOM_CNTS_PASSWD_PAGE] = SSERV_OP_USER_SEL_RANDOM_PASSWD_PAGE,
+  [SSERV_OP_USER_SEL_DELETE_REG_PAGE] = SSERV_OP_USER_SEL_RANDOM_PASSWD_PAGE,
+  [SSERV_OP_USER_SEL_CHANGE_REG_STATUS_PAGE] = SSERV_OP_USER_SEL_RANDOM_PASSWD_PAGE,
+  [SSERV_OP_USER_SEL_CHANGE_REG_FLAGS_PAGE] = SSERV_OP_USER_SEL_RANDOM_PASSWD_PAGE,
+  [SSERV_OP_USER_SEL_CREATE_REG_PAGE] = SSERV_OP_USER_SEL_RANDOM_PASSWD_PAGE,
+  [SSERV_OP_USER_SEL_CREATE_REG_AND_COPY_PAGE] = SSERV_OP_USER_SEL_RANDOM_PASSWD_PAGE,
+  [SSERV_OP_USER_SEL_CREATE_GROUP_MEMBER_PAGE] = SSERV_OP_USER_SEL_RANDOM_PASSWD_PAGE,
+  [SSERV_OP_USER_SEL_DELETE_GROUP_MEMBER_PAGE] = SSERV_OP_USER_SEL_RANDOM_PASSWD_PAGE,
+
+  [SSERV_OP_USER_SEL_CLEAR_CNTS_PASSWD_ACTION] = SSERV_OP_USER_SEL_RANDOM_PASSWD_ACTION,
+  [SSERV_OP_USER_SEL_RANDOM_CNTS_PASSWD_ACTION] = SSERV_OP_USER_SEL_RANDOM_PASSWD_ACTION,
+  [SSERV_OP_USER_SEL_DELETE_REG_ACTION] = SSERV_OP_USER_SEL_RANDOM_PASSWD_ACTION,
+  [SSERV_OP_USER_SEL_CHANGE_REG_STATUS_ACTION] = SSERV_OP_USER_SEL_RANDOM_PASSWD_ACTION,
+  [SSERV_OP_USER_SEL_CHANGE_REG_FLAGS_ACTION] = SSERV_OP_USER_SEL_RANDOM_PASSWD_ACTION,
+  [SSERV_OP_USER_SEL_CREATE_REG_ACTION] = SSERV_OP_USER_SEL_RANDOM_PASSWD_ACTION,
+  [SSERV_OP_USER_SEL_CREATE_REG_AND_COPY_ACTION] = SSERV_OP_USER_SEL_RANDOM_PASSWD_ACTION,
+  [SSERV_OP_USER_SEL_CREATE_GROUP_MEMBER_ACTION] = SSERV_OP_USER_SEL_RANDOM_PASSWD_ACTION,
+  [SSERV_OP_USER_SEL_DELETE_GROUP_MEMBER_ACTION] = SSERV_OP_USER_SEL_RANDOM_PASSWD_ACTION,
+
+  [SSERV_OP_USER_SEL_VIEW_CNTS_PASSWD_PAGE] = SSERV_OP_USER_SEL_VIEW_PASSWD_PAGE,
+  [SSERV_OP_USER_SEL_VIEW_CNTS_PASSWD_REDIRECT] = SSERV_OP_USER_SEL_VIEW_PASSWD_REDIRECT,
+
+  [SSERV_OP_GROUP_FILTER_FIRST_PAGE_ACTION] = SSERV_OP_GROUP_FILTER_CHANGE_ACTION,
+  [SSERV_OP_GROUP_FILTER_PREV_PAGE_ACTION] = SSERV_OP_GROUP_FILTER_CHANGE_ACTION,
+  [SSERV_OP_GROUP_FILTER_NEXT_PAGE_ACTION] = SSERV_OP_GROUP_FILTER_CHANGE_ACTION,
+  [SSERV_OP_GROUP_FILTER_LAST_PAGE_ACTION] = SSERV_OP_GROUP_FILTER_CHANGE_ACTION,
+};
+
 static handler_func_t op_handlers[SSERV_OP_LAST] =
 {
   [SSERV_OP_VIEW_CNTS_DETAILS] = cmd_cnts_details,
@@ -6541,24 +6750,79 @@ static handler_func_t op_handlers[SSERV_
   [SSERV_OP_CLEAR_SERVE_PROB_FIELD] = cmd_op_clear_serve_prob_field,
   [SSERV_OP_EDIT_SERVE_PROB_FIELD_DETAIL_PAGE] = cmd_op_edit_serve_prob_field_detail_page,
   [SSERV_OP_EDIT_SERVE_PROB_FIELD_DETAIL] = cmd_op_edit_serve_prob_field_detail,
+
   [SSERV_OP_BROWSE_PROBLEM_PACKAGES] = super_serve_op_browse_problem_packages,
   [SSERV_OP_CREATE_PACKAGE] = super_serve_op_package_operation,
   [SSERV_OP_CREATE_PROBLEM] = super_serve_op_edit_problem,
   [SSERV_OP_DELETE_ITEM] = super_serve_op_package_operation,
   [SSERV_OP_EDIT_PROBLEM] = super_serve_op_edit_problem,
+
+  /* Note: operations SSERV_OP_USER_*, SSERV_OP_GROUP_* are loaded using dlsym */
 };
 
+extern void super_html_6_force_link(void);
+void *super_html_6_force_link_ptr = super_html_6_force_link;
+
+static void *self_dl_handle = 0;
 static int
 do_http_request(FILE *log_f, FILE *out_f, struct super_http_request_info *phr)
 {
   int opcode = 0;
   int retval = 0;
+  int n = 0;
+  const unsigned char *s = 0;
 
-  if (ss_cgi_param_int(phr, "op", &opcode) < 0
-      || opcode <= 0 || opcode >= SSERV_OP_LAST || !op_handlers[opcode])
+  if ((s = ss_cgi_nname(phr, "op_", 3))) {
+    if (sscanf(s, "op_%d%n", &opcode, &n) != 1 || s[n]
+        || opcode <= 0 || opcode >= SSERV_OP_LAST)
+      FAIL(S_ERR_INV_OPER);
+  } else if (ss_cgi_param_int(phr, "op", &opcode) < 0
+      || opcode <= 0 || opcode >= SSERV_OP_LAST)
     FAIL(S_ERR_INV_OPER);
+
+  if (!op_names[opcode]) FAIL(S_ERR_INV_OPER);
+  if (op_handlers[opcode] == (handler_func_t) 1) FAIL(S_ERR_NOT_IMPLEMENTED);
   phr->opcode = opcode;
 
+  if (!op_handlers[opcode]) {
+    if (self_dl_handle == (void*) 1) FAIL(S_ERR_NOT_IMPLEMENTED);
+    self_dl_handle = dlopen(NULL, RTLD_NOW);
+    if (!self_dl_handle) {
+      err("do_http_request: dlopen failed: %s", dlerror());
+      self_dl_handle = (void*) 1;
+      FAIL(S_ERR_NOT_IMPLEMENTED);
+    }
+
+    int redir_opcode = opcode;
+    if (op_redirect[opcode] > 0) {
+      redir_opcode = op_redirect[opcode];
+      if (redir_opcode <= 0 || redir_opcode >= SSERV_OP_LAST || !op_names[redir_opcode]) {
+        err("do_http_request: invalid opcode redirect %d->%d", opcode, redir_opcode);
+        op_handlers[opcode] = (handler_func_t) 1;
+        FAIL(S_ERR_NOT_IMPLEMENTED);
+      }
+      if (op_handlers[redir_opcode] == (handler_func_t) 1) {
+        err("do_http_request: not implemented opcode redirect %d->%d", opcode, redir_opcode);
+        op_handlers[opcode] = (handler_func_t) 1;
+        FAIL(S_ERR_NOT_IMPLEMENTED);
+      }
+    }
+
+    if (op_handlers[redir_opcode]) {
+      op_handlers[opcode] = op_handlers[redir_opcode];
+    } else {
+      unsigned char func_name[512];
+      snprintf(func_name, sizeof(func_name), "super_serve_op_%s", op_names[redir_opcode]);
+      void *void_func = dlsym(self_dl_handle, func_name);
+      if (!void_func) {
+        err("do_http_request: function %s is not found", func_name);
+        op_handlers[opcode] = (handler_func_t) 1;
+        FAIL(S_ERR_NOT_IMPLEMENTED);
+      }
+      op_handlers[opcode] = (handler_func_t) void_func;
+    }
+  }
+
   retval = (*op_handlers[opcode])(log_f, out_f, phr);
 
  cleanup:
@@ -6586,6 +6850,34 @@ static unsigned char const * const error
   [S_ERR_INV_PACKAGE] = "Invalid package",
   [S_ERR_ITEM_EXISTS] = "Such item already exists",
   [S_ERR_OPERATION_FAILED] = "System operation failed",
+  [S_ERR_INV_USER_ID] = "Invalid User ID",
+  [S_ERR_NO_CONNECTION] = "No connection to the database",
+  [S_ERR_DB_ERROR] = "Database error",
+  [S_ERR_UNSPEC_PASSWD1] = "Password 1 is not specified",
+  [S_ERR_UNSPEC_PASSWD2] = "Password 2 is not specified",
+  [S_ERR_INV_PASSWD1] = "Password 1 is invalid",
+  [S_ERR_INV_PASSWD2] = "Password 2 is invalid",
+  [S_ERR_PASSWDS_DIFFER] = "Passwords do not match each other",
+  [S_ERR_UNSPEC_LOGIN] = "Login is not specified",
+  [S_ERR_DUPLICATED_LOGIN] = "This login is aready used",
+  [S_ERR_INV_GROUP_ID] = "Invalid group ID",
+  [S_ERR_INV_FIRST_SERIAL] = "Invalid first serial number",
+  [S_ERR_INV_LAST_SERIAL] = "Invalid last serial number",
+  [S_ERR_INV_RANGE] = "Invalid serial number range",
+  [S_ERR_INV_LOGIN_TEMPLATE] = "Invalid login template",
+  [S_ERR_INV_REG_PASSWORD_TEMPLATE] = "Invalid registration password template",
+  [S_ERR_INV_CNTS_PASSWORD_TEMPLATE] = "Invalid contest password template",
+  [S_ERR_INV_CNTS_NAME_TEMPLATE] = "Invalid name template",
+  [S_ERR_INV_CSV_FILE] = "Invalid CSV file",
+  [S_ERR_INV_CHARSET] = "Invalid charset",
+  [S_ERR_INV_SEPARATOR] = "Invalid field separator",
+  [S_ERR_DATA_READ_ONLY] = "Data is read-only",
+  [S_ERR_TOO_MANY_MEMBERS] = "Too many members",
+  [S_ERR_INV_SERIAL] = "Invalid member",
+  [S_ERR_INV_EMAIL] = "Invalid email",
+  [S_ERR_INV_GROUP_NAME] = "Invalid group name",
+  [S_ERR_INV_DESCRIPTION] = "Invalid description",
+  [S_ERR_GROUP_CREATION_FAILED] = "Group creation failed",
 };
 
 void
